Attribute VB_Name = "IRMMacros"
 'Licensed Materials - Property of IBM
 '"Restricted Materials of IBM"
 '5746-SM2
 '  Copyright IBM Corp. 1999, 2003, 2004 All Rights Reserved.
 'US Government Users Restricted Rights - Use, duplication or
 'disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
Option Explicit

' need references to
' IRMEmailModule.dll
' IRMProxies.tlb
' Microsoft Scripting Runtime
'.NET Runtime

Public Const lEmailID As Variant = 21
Public Const lAttachmentID As Variant = 22
Public Const lCrossReferenceViewID As Variant = 21
Public Const IRM_EMAIL = "IRM 4.1 Email"
Public Const strServerURL As String = "http://localhost:9080/IRMWebServices/services/"
' declare windows API function to get temporary path
Private Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long

' display error message
Public Sub DisplayError(ByRef Error As ErrObject)

    If Error.Number = -2147216500 Then
        MsgBox "Invalid Cross Reference ID - relationship not defined.  Verify ID in Macro."
        Exit Sub
    End If
    ' DOM object
    Dim objXml As MSXML2.DOMDocument
    Set objXml = New MSXML2.DOMDocument
    
    ' try to load error description as xml
    If objXml.loadXML(Error.Description) Then
        ' DOM node object
        Dim objElement As MSXML2.IXMLDOMNode
        ' error number
        Dim strNumber As String
        ' error description
        Dim strDescription As String
        ' error source
        Dim strSource As String
        ' dll error comes from
        Dim strDll As String
        
        ' navigate through xml to get topmost error info
        For Each objElement In objXml.selectSingleNode("Errors").childNodes(0).childNodes
            Select Case objElement.nodeName
                Case "Code"
                    strNumber = CStr(objElement.Text)
                Case "Description"
                    strDescription = CStr(objElement.Text)
                Case "Source"
                    strSource = CStr(objElement.Text)
                Case "DllApp"
                    strDll = CStr(objElement.Text)
            End Select
        Next
        Set objElement = Nothing
        Set objXml = Nothing
        MsgBox "Description: " & strDescription & vbCrLf & "Code: " & CStr(Error.Number) & "(" & strNumber & ")" & vbCrLf & "Source: " & strSource, vbCritical Or vbOKOnly, strDll
    Else
        MsgBox "Error number: " & CStr(Hex(Error.Number)) & "(" & CStr(Error.Number) & ")" & vbCrLf & Error.Description
    End If
End Sub

' declare record on send
Sub DeclareRecordOnSend(ByVal Item As Object, Cancel As Boolean)
    
On Error GoTo initError
    
    ' define mail item
    Dim oMailItem As MailItem
    ' assign from the passed in item
    Set oMailItem = Item
    
    ' is it a mail item
    If TypeName(oMailItem) = "MailItem" Then
        
        ' call declaration code
        DeclareMailItem oMailItem, True
        
    End If
    
    Exit Sub

' show error message
initError:
    DisplayError Err
    ' clear error object
    Err.Clear

End Sub

' declare selected email as record when toolbar button pressed
Public Sub DeclareRecordOnButton()
    
On Error GoTo initError
    
    ' define mail item
    Dim oMailItem As MailItem
    ' define mail explorer
    Dim oeExplorer As Explorer
    ' define selected mail item list
    Dim oscSelection As Selection

    ' assign explorer from active one
    Set oeExplorer = Application.ActiveExplorer
    ' assign seletion from current selection
    Set oscSelection = oeExplorer.Selection

    ' index to navigate selected mail items
    Dim lIndex As Long

    ' loop through selected mail items
    For lIndex = 1 To oscSelection.Count
        ' filter mail items
        If TypeName(oscSelection.Item(lIndex)) = "MailItem" Then
            Set oMailItem = oscSelection.Item(lIndex)
            
            ' call declaration code
            DeclareMailItem oMailItem, False
            
        End If
    Next lIndex
    
    Exit Sub

' show error message
initError:
    DisplayError Err
    Err.Clear

End Sub

' login function
Private Function Login(ByVal bShowForm As Boolean) As Boolean

On Error GoTo initError
    
    ' login name
    Dim strLoginName As String
    ' session
    Dim strSession As String
    ' password
    Dim strPassword As String
    ' db alias
    Dim strDatabase As String
    ' host name
    Dim strHostName As String
    ' TsBll login manager object
    Dim objLoginManagerClass As New IRMProxies.LoginManagerEJBBeanService
    Dim objLoginManager As IRMProxies.ILoginManagerEJBBeanService
    objLoginManagerClass.url = strServerURL & "LoginManagerEJBBean"
    Set objLoginManager = objLoginManagerClass
    'objLoginManager.url = strServerURL
    ' do we have to show login form
    If bShowForm Then
        ' show login form
        frmLogin.Show vbModal
        ' OK pressed
        Login = frmLogin.bOK
        If frmLogin.bOK Then
            ' save login information in local variables
            strLoginName = frmLogin.strLoginName
            strPassword = frmLogin.strPassword
            strDatabase = frmLogin.strDatabase
            strHostName = frmLogin.strHostName
            ' login
            strSession = objLoginManager.integrationLogin(strLoginName, strPassword, strDatabase, "", "")
            ' save session
            frmLogin.strSession = strSession
        End If
    Else
        Login = True
        ' save login information in local variables
        strLoginName = frmLogin.strLoginName
        strPassword = frmLogin.strPassword
        strDatabase = frmLogin.strDatabase
        strHostName = frmLogin.strHostName
        ' login
        strSession = objLoginManager.integrationLogin(strLoginName, strPassword, strDatabase, "", "")
        ' save session
        frmLogin.strSession = strSession
    End If
    Set objLoginManager = Nothing
    
    Exit Function
    
initError:
    ' login failed ?
    Login = False
    DisplayError Err
    Err.Clear

End Function

' logout function
Private Sub Logout()
    
On Error GoTo initError

    ' session
    Dim strSession As String
    ' get saved sassion value
    strSession = frmLogin.strSession
    
    ' TsBll login manager object
    'Dim objLoginManager As IRMProxies.LoginManagerEJBService
    'Set objLoginManager = New IRMProxies.LoginManagerEJBService
    'objLoginManager.url = strServerURL
    ' logout
    'objLoginManager.Logout
   ' Set objLoginManager = Nothing
    
    Exit Sub

initError:
    ' failed to logout ?
    DisplayError Err
    Err.Clear

End Sub

' main declaration code
Public Sub DeclareMailItem(objMailItem As MailItem, ByVal bSend As Boolean)
        
On Error GoTo initError

    ' session variable
    Dim strSession As String
    ' get saved session value
    strSession = frmLogin.strSession
    Dim objHeader As IRMProxies.IRMHeader
    Set objHeader = New IRMProxies.IRMHeader
    objHeader.serviceId = strSession
    Dim nHostID As Variant
    ' login test variable
    Dim bOK As Boolean
    bOK = True
    
    ' did we login once ?
    If Not Len(strSession) > 0 Then
        bOK = Login(True)
    Else
        bOK = Login(False)
    End If
    
    ' store session in local variable
    strSession = frmLogin.strSession
    
    ' logged in
    If bOK Then
        Dim objCC As IRMProxies.IClientControllerEJBBeanService
        Dim objCCClass As New IRMProxies.ClientControllerEJBBeanService
        Set objCC = objCCClass
        objCCClass.url = strServerURL & "ClientControllerEJBBean"
        objHeader.serviceId = strSession
        Set objCCClass.ID = objHeader
        Dim strConfigControllerKey As String
        strConfigControllerKey = objCC.getConfigurationControllerAsString
        
        Dim objConfigurationController As IRMProxies.IConfigurationControllerEJBBeanService
        Dim objConfigurationControllerClass As New IRMProxies.ConfigurationControllerEJBBeanService
        Set objConfigurationController = objConfigurationControllerClass
        objConfigurationControllerClass.url = strServerURL & "ConfigurationControllerEJBBean"
        objHeader.serviceId = strConfigControllerKey
        Set objConfigurationControllerClass.ID = objHeader
    
        Dim strConfigurationKey As String
        'strConfigurationKey = objConfigurationController.getConfigurationControllerAsString()
        'objHeader.EJBKey = strConfigurationKey
        'Set objConfigurationController.headerValue = objHeader
        'On Error Resume Next
        If frmLogin.strHostName <> "" Then
           nHostID = objConfigurationController.getHostIDByHostName(frmLogin.strHostName)
        End If
        Dim bGo As Boolean
        bGo = True
        
        Dim enmOptionButton As enumOptionButtons
        ' declare as a single record by default if there is no attachments
        enmOptionButton = obSingle
        
        ' are there any attachments in mail message ?
        If objMailItem.Attachments.Count > 0 Then
            'if this is an embedded object then send as a single record without displaying a decration form
            'Andy asked for it
            Dim objAttachItem As Attachment
            Dim blnShowDeclarationForm As Boolean
            blnShowDeclarationForm = True
            For Each objAttachItem In objMailItem.Attachments
                blnShowDeclarationForm = True
                bGo = False
                If objAttachItem.Type = olEmbeddeditem Or objAttachItem.Type = OlAttachmentType.olOLE Then
                    bGo = True
                    enmOptionButton = obSingle
                    blnShowDeclarationForm = False
                    'Exit For
                End If
            Next
            If blnShowDeclarationForm Then
                ' create declaration options form
                Dim frmDO As New frmDeclarationOptions
                ' show declaration options form
                frmDO.Show vbModal
                ' user made a selection, is it ok or cancel
                If frmDO.bOK Then
                    ' what was the selection
                    enmOptionButton = frmDO.enmOptionButton
                    bGo = True
                End If
                ' unload form
                Unload frmDO
                Set frmDO = Nothing
            Else
                bGo = True
            End If
        End If
        
        ' user vants to declare mail message as a record
        If bGo Then
        
            ' This is an ActiveX control object provided by Tarian Software. When you call the ShowProfile method,
            ' the control displays a dialog box and provides all the necessary UI functionality to pass DoD certification.
            ' set this Reference in the macro IDE
            Dim objEmailModule As EmailModule
            
            ' filing system object
            Dim objFS As Scripting.FileSystemObject
            
            ' file plan component object
                        
           
            Dim strFilePlanComponentKey As String
            objHeader.serviceId = strSession
            strFilePlanComponentKey = objCC.getFilePlanComponentControllerAsString()
            
            Dim strFPCContentKey As String
            strFPCContentKey = objCC.getFilePlanComponentContentControllerAsString
            
            Dim strNavigationControllerKey As String
            strNavigationControllerKey = objCC.getNavigationControllerAsString
            
            Dim objFilePlanComponent As IRMProxies.IFilePlanComponentContentControllerEJBBeanService
            Dim objFilePlanComponentClass As New IRMProxies.FilePlanComponentContentControllerEJBBeanService
            Set objFilePlanComponent = objFilePlanComponentClass
            objFilePlanComponentClass.url = strServerURL & "FilePlanComponentControllerEJBBean"
            objHeader.serviceId = strFilePlanComponentKey
            Set objFilePlanComponentClass.ID = objHeader
            
            ' temporary mail item object
            Dim objTempMailItem As Outlook.MailItem
            
            ' file name
            Dim strFileName As String
            ' attachment object
            Dim objAttachment As Outlook.Attachment
            ' dialog caption
            Dim strCaption As String
            ' target list string
            Dim strTargetList As String
            
            ' This string is returned by the TsEmailModule2.ShowProfile method and contains the selected classification
            ' value for the email record
            Dim strClassification As String
            
            ' attachment coung
            Dim lFiledAttachmentCount As Integer
            ' temporary path
            Dim strTempPath As String
            ' length of the temporary path
            Dim lTempPath As Long
            
            ' This string is returned from the TsEmailModule2.ShowProfile method. It contains all the record profile data
            ' for the email message.
            Dim strResultXml As String
            
            ' version id in rmaHost
            Dim lVersionID As Variant
            
            ' filed email id
            ' This variable will hold the TARIAN record ID after we create the new File plan component for email message
            Dim lFiledEmailID As Variant
            
            ' filed attachment id
            ' This variable will hold the TARIAN record ID after we create the new File plan component for email attachment
            Dim lFiledAttachmentID As Variant
            
            ' external record id
            Dim vXternalRecordID As Variant
            
            ' This variable will hold the TARIAN assigned HostID value for YOUR host application.
            ' Set this number to equal your HostID. You can get this from the Tarian API.
            Dim vHostID As Variant
            
            ' initialise as no attachments
            lFiledAttachmentCount = 0
            
            ' how are we declaring
            Select Case enmOptionButton

                ' both email and attachments
                Case obBoth
                    
                    ' create object instances
                    Set objFS = CreateObject("Scripting.FileSystemObject")
                    
                    ' Create  TsEmailModule2 object
                    Set objEmailModule = CreateObject("IRMEmailModule.EmailModule")
                    
                    ' pass file plan component definition id to the profile
                    objEmailModule.lFilePlanComponentDefinitionID = lEmailID
                    ' is email being sent ?
                    objEmailModule.bSend = bSend
                    ' pass email object to the profile
                    Set objEmailModule.objMailItem = objMailItem
                    ' pass session to the profile
                    objEmailModule.strSession = strSession
                    objEmailModule.strURL = strServerURL
                    ' allocate temporary path variable
                    strTempPath = String(257, " ")
                    ' get temporary path
                    lTempPath = GetTempPath(256, strTempPath)
                    ' construct file name to save email
                    strFileName = Left(strTempPath, lTempPath) & Replace(objFS.GetTempName, ".tmp", ".msg")
                    ' save email to a disk file
                    objMailItem.SaveAs strFileName, olMSG
                    ' pass file name to the profile
                    objEmailModule.strFileName = strFileName
                    ' profile form caption
                    objEmailModule.strCaption = "e-Record Profile: " & strFileName
                    ' this is not an attachment
                    objEmailModule.bAttachment = False
                    
                    ' Show Email Profile and collect data for email message
                    strResultXml = objEmailModule.ShowProfile(strClassification)
                    ' user wants to declare a record
                    If Len(strResultXml) > 0 And Len(strClassification) > 0 And objEmailModule.bOK = True Then
                    
                        ' Declare as record
                        lFiledEmailID = DeclareAsRecord(strFilePlanComponentKey, strFPCContentKey, strFileName, strResultXml, strClassification, lEmailID, nHostID)
                        
                        ' delete local file
                        objFS.DeleteFile strFileName, True
                        
                        ' list of attachments to create link with main email
                        strTargetList = "<List>"
                        
                        ' let's declare all attachments
                        For Each objAttachment In objMailItem.Attachments
                            ' is email being sent ?
                            objEmailModule.bSend = bSend
                            ' pass email object
                            Set objEmailModule.objMailItem = objMailItem
                            ' pass file plan component definition id for attachment
                            objEmailModule.lFilePlanComponentDefinitionID = lAttachmentID
                            ' pass session
                            objEmailModule.strSession = strSession
                            ' allocate string for temporary path
                            strTempPath = String(257, " ")
                            ' get temporary path
                            lTempPath = GetTempPath(256, strTempPath)
                            ' build local file name for the attachment
                            strFileName = Left(strTempPath, lTempPath) & objAttachment.FileName
                            ' save attachment to a local disk file
                            objAttachment.SaveAsFile strFileName
                            ' pass file name
                            objEmailModule.strFileName = strFileName
                            ' set caption for the profile
                            objEmailModule.strCaption = "e-Record Profile: " & strFileName
                            ' it is an attachment
                            objEmailModule.bAttachment = True
                            
                            ' Show Email Profile and collect data for attachment
                            strResultXml = objEmailModule.ShowProfile(strClassification)
                            
                            ' user wants to declare current attachment
                            If Len(strResultXml) > 0 And Len(strClassification) > 0 And objEmailModule.bOK = True Then
                                
                                ' Declare as record
                                lFiledAttachmentID = DeclareAsRecord(strFilePlanComponentKey, strFPCContentKey, strFileName, strResultXml, strClassification, lAttachmentID, nHostID)
                                
                                ' delete local file
                                objFS.DeleteFile strFileName, True
                        
                                ' add declared attachment to target list
                                strTargetList = strTargetList & "<Item FlPlnCmpntID=""" & lFiledAttachmentID & """ FlPlnViewID=""" & lCrossReferenceViewID & """/>"
                                
                                ' increment count for declared attachments
                                lFiledAttachmentCount = lFiledAttachmentCount + 1
                            End If
                        Next
                        ' finish xml target list construction
                        strTargetList = strTargetList & "</List>"
                        ' add link to the main email for all declared attachments
                        
                        If lFiledAttachmentCount > 0 Then objFilePlanComponent.addTarget lFiledEmailID, strTargetList
                    End If

                Case obSeparate

                    ' create object instances
                    Set objFS = CreateObject("Scripting.FileSystemObject")
                    
                    ' Create  TsEmailModule2 object
                    Set objEmailModule = CreateObject("IRMEmailModule.EmailModule")
                    
                    ' pass file plan component definition id to the profile
                    objEmailModule.lFilePlanComponentDefinitionID = lEmailID
                    ' is email being sent ?
                    objEmailModule.bSend = bSend
                    ' pass email object to the profile
                    Set objEmailModule.objMailItem = objMailItem
                    ' pass session to the profile
                    objEmailModule.strSession = strSession
                    objEmailModule.strURL = strServerURL
                    ' create a copy object for main email
                    Set objTempMailItem = objMailItem.Copy
                    ' remove all attachments from email copy
                    While objTempMailItem.Attachments.Count > 0
                        objTempMailItem.Attachments.Item(objTempMailItem.Attachments.Count).Delete
                    Wend
                    ' save email copy without attachments
                    objTempMailItem.Save

                    ' allocate temporary path variable
                    strTempPath = String(257, " ")
                    ' get temporary path
                    lTempPath = GetTempPath(256, strTempPath)
                    ' construct file name to save email
                    strFileName = Left(strTempPath, lTempPath) & Replace(objFS.GetTempName, ".tmp", ".msg")
                    ' save email to a disk file
                    objTempMailItem.SaveAs strFileName, olMSG
                    ' pass file name to the profile
                    objEmailModule.strFileName = strFileName
                    ' profile form caption
                    objEmailModule.strCaption = "e-Record Profile: " & strFileName
                    ' this is not an attachment
                    objEmailModule.bAttachment = False
                    
                    ' Show Email Profile and collect data for email message
                    strResultXml = objEmailModule.ShowProfile(strClassification)
                    
                    ' user wants to declare a record
                    If Len(strResultXml) > 0 And Len(strClassification) > 0 And objEmailModule.bOK = True Then
                       
                        ' Declare as record
                        lFiledEmailID = DeclareAsRecord(strFilePlanComponentKey, strFPCContentKey, strFileName, strResultXml, strClassification, lEmailID, nHostID)
                        
                        ' delete local file
                        objFS.DeleteFile strFileName, True
                        ' delete email copy
                        objTempMailItem.Delete
                        
                        ' list of attachments to create link with main email
                        strTargetList = "<List>"
                        
                        ' let's declare all attachments
                        For Each objAttachment In objMailItem.Attachments
                            ' is email being sent ?
                            objEmailModule.bSend = bSend
                            ' pass email object
                            Set objEmailModule.objMailItem = objMailItem
                            ' pass file plan component definition id for attachment
                            objEmailModule.lFilePlanComponentDefinitionID = lAttachmentID
                            ' pass session
                            objEmailModule.strSession = strSession
                            ' allocate string for temporary path
                            strTempPath = String(257, " ")
                            ' get temporary path
                            lTempPath = GetTempPath(256, strTempPath)
                            ' build local file name for the attachment
                            strFileName = Left(strTempPath, lTempPath) & objAttachment.FileName
                            ' save attachment to a local disk file
                            objAttachment.SaveAsFile strFileName
                            ' pass file name
                            objEmailModule.strFileName = strFileName
                            ' set caption for the profile
                            objEmailModule.strCaption = "e-Record Profile: " & strFileName
                            ' it is an attachment
                            objEmailModule.bAttachment = True
                            
                            ' Show Email Profile and collect data for attachment
                            strResultXml = objEmailModule.ShowProfile(strClassification)
                            
                            ' user wants to declare current attachment
                            If Len(strResultXml) > 0 And Len(strClassification) > 0 And objEmailModule.bOK = True Then
                                
                                ' Declara as record
                                lFiledAttachmentID = DeclareAsRecord(strFilePlanComponentKey, strFPCContentKey, strFileName, strResultXml, strClassification, lAttachmentID, nHostID)
                                
                                ' delete local file
                                objFS.DeleteFile strFileName, True
                                
                                ' add declared attachment to target list
                                strTargetList = strTargetList & "<Item FlPlnCmpntID=""" & lFiledAttachmentID & """ FlPlnViewID=""" & lCrossReferenceViewID & """/>"
                                
                                ' increment count for declared attachments
                                lFiledAttachmentCount = lFiledAttachmentCount + 1
                            End If
                        Next
                        ' finish xml target list construction
                        strTargetList = strTargetList & "</List>"
                        ' add link to the main email for all declared attachments
                        If lFiledAttachmentCount > 0 Then objFilePlanComponent.addTarget lFiledEmailID, strTargetList
                    End If
                    Set objTempMailItem = Nothing

                Case obSingle
                    
                    ' create object instances
                    Set objFS = CreateObject("Scripting.FileSystemObject")
                    ' Create  IRMEmailModule object

                    Set objEmailModule = New EmailModule
                    
                    ' pass file plan component definition id to the profile
                    objEmailModule.lFilePlanComponentDefinitionID = lEmailID
                    ' is email being sent ?
                    objEmailModule.bSend = bSend
                    ' pass email object to the profile
                    Set objEmailModule.objMailItem = objMailItem
                    ' pass session to the profile
                    objEmailModule.strSession = strSession
                    objEmailModule.strURL = strServerURL
                    ' allocate temporary path variable
                    strTempPath = String(257, " ")
                    ' get temporary path
                    lTempPath = GetTempPath(256, strTempPath)
                    ' construct file name to save email
                    strFileName = Left(strTempPath, lTempPath) & Replace(objFS.GetTempName, ".tmp", ".msg")
                    ' save email to a disk file
                    objMailItem.SaveAs strFileName, olMSG
                    ' pass file name to the profile
                    objEmailModule.strFileName = strFileName
                    ' profile form caption
                    objEmailModule.strCaption = "e-Record Profile: " & strFileName
                    ' this is not an attachment
                    objEmailModule.bAttachment = False
                    
                    ' Show Email Profile and collect data for email message
                    strResultXml = objEmailModule.ShowProfile(strClassification)
                    
                    ' user wants to declare a record
                    If Len(strResultXml) > 0 And Len(strClassification) > 0 And objEmailModule.bOK = True Then
                        
                        ' Declare as record
                        lFiledEmailID = DeclareAsRecord(strFilePlanComponentKey, strFPCContentKey, strFileName, strResultXml, strClassification, lEmailID, nHostID)
                        ' delete local file
                        
                        objFS.DeleteFile strFileName, True
                        
                    End If

            End Select
        
        End If
        
        ' release objects
        Set objEmailModule = Nothing
        Set objFS = Nothing
        Set objAttachment = Nothing
        Set objFilePlanComponent = Nothing
        
        ' logout
        Logout
    End If

    Exit Sub

initError:
    DisplayError Err
    Set objEmailModule = Nothing
    If Not objFS Is Nothing Then
        If objFS.FileExists(strFileName) Then objFS.DeleteFile strFileName, True
        Set objFS = Nothing
    End If
    Set objAttachment = Nothing
    Set objFilePlanComponent = Nothing
    Set objTempMailItem = Nothing
    Err.Clear
    
End Sub


' upload local file to the server
Private Function ConvertToBase64(ByVal strFileName As String) As String

    Dim bytData() As Byte

    Dim f As Integer
    f = FreeFile()
    Open strFileName For Binary Access Read As #f
    If LOF(f) > 0 Then ReDim bytData(LOF(f) - 1)
    Get #f, 1, bytData()
    Close #f
    Dim DomDOc As MSXML2.DOMDocument
    Set DomDOc = CreateObject("MSXML2.DOMDocument")
    
    Dim DOMElement As MSXML2.IXMLDOMElement
    Set DOMElement = DomDOc.createElement("Temp")
    
    DOMElement.dataType = "bin.base64"
    DOMElement.nodeTypedValue = bytData
    
    ConvertToBase64 = DOMElement.Text

    Set DomDOc = Nothing
    Set DOMElement = Nothing
    
End Function

' update file plan component xml with external record id and host id
Private Sub UpdateProfileXmlWithXternalRecordID(strProfileXML As String, ByVal strXternalRecordID As String, ByVal strHostID As String)
    Dim objXml As MSXML2.DOMDocument
    Dim xmlNode As MSXML2.IXMLDOMNode
    
    Set objXml = New MSXML2.DOMDocument
    If objXml.loadXML(strProfileXML) Then
        For Each xmlNode In objXml.selectSingleNode("Fields").childNodes
            If StrComp(LCase(xmlNode.Attributes.getNamedItem("FlPlnCmpntAttrDefColNm").Text), LCase("XtRecID")) = 0 Then
                xmlNode.Text = strXternalRecordID
            End If
            If StrComp(LCase(xmlNode.Attributes.getNamedItem("FlPlnCmpntAttrDefColNm").Text), LCase("RecHsID")) = 0 Then
                xmlNode.Text = strHostID
            End If
        Next
        strProfileXML = objXml.xml
    End If
End Sub

Public Sub ClearLogin()
 
    frmLogin.txtHostName.Text = ""
    frmLogin.txtLoginName.Text = ""
    frmLogin.txtPassword.Text = ""
    frmLogin.txtHostName.Text = ""
    frmLogin.strSession = ""
    frmLogin.strPassword = ""
    frmLogin.strHostName = ""
    frmLogin.strLoginName = ""
    
End Sub

Private Function DeclareAsRecord(strFilePlanComponentKey As String, strFPCContentKey As String, strFileName As String, strResultXml As String, strClassification As String, lFilePlanComponentDefinitionID As Variant, ByVal nHostID As Variant) As Variant
    Dim nNewRecordID As Variant
    
    Dim objFilePlanComponentContent As IRMProxies.IFilePlanComponentContentControllerEJBBeanService
    Dim objFilePlanComponentContentClass As New IRMProxies.FilePlanComponentContentControllerEJBBeanService
    Set objFilePlanComponentContent = objFilePlanComponentContentClass
    objFilePlanComponentContentClass.url = strServerURL & "FilePlanComponentContentControllerEJBBean"
    
    Dim objFPCContentHeader As IRMProxies.IRMHeader
    Set objFPCContentHeader = New IRMProxies.IRMHeader
    objFPCContentHeader.serviceId = strFPCContentKey
    Set objFilePlanComponentContentClass.ID = objFPCContentHeader
    
    Dim objFilePlanComponent As IRMProxies.IFilePlanComponentControllerEJBBeanService
    Dim objFilePlanComponentClass As New IRMProxies.FilePlanComponentControllerEJBBeanService
    Set objFilePlanComponent = objFilePlanComponentClass
    objFilePlanComponentClass.url = strServerURL & "FilePlanComponentControllerEJBBean"
    
    Dim objFPCHeader As IRMProxies.IRMHeader
    Set objFPCHeader = New IRMProxies.IRMHeader
    objFPCHeader.serviceId = strFilePlanComponentKey
    Set objFilePlanComponentClass.ID = objFPCHeader
    
    nNewRecordID = objFilePlanComponent.addFilePlanComponentToFullPath(lFilePlanComponentDefinitionID, strResultXml, strClassification, 1)
    
    'add a rendition
    Dim nStreamID As Variant
    Dim strFullPath As String
    Dim lDot As Long
    lDot = InStrRev(strFileName, ".", -1, vbTextCompare)
    Dim strFileExtension As String
    strFileExtension = Right(strFileName, Len(strFileName) - lDot)
    If lDot > 0 Then
        strFileExtension = "." & strFileExtension
    End If
    If lFilePlanComponentDefinitionID = lAttachmentID Then
        nStreamID = objFilePlanComponentContent.openContentStreamForWrite(nNewRecordID, nHostID, "Attachment " & strFileExtension, "")
    Else
        nStreamID = objFilePlanComponentContent.openContentStreamForWrite(nNewRecordID, nHostID, "Message.msg", "")
    End If
    Dim strBase64String As String
    strBase64String = ConvertToBase64(strFileName)
    'Following lines are intended to remove line feed characters from the Base64 string. Line feed characters are not
    'part of the base64 string and therefore can be safely removed. Otherwise, org.apache.soap.encoding.Base64.decode
    'method might not produce correct results.
    Dim arraySplit() As String
    arraySplit = Split(strBase64String, Chr(10), -1, vbBinaryCompare)
    strBase64String = Join(arraySplit, "")
    objFilePlanComponentContent.writeContentStream nStreamID, strBase64String
    objFilePlanComponentContent.closeContentStream nStreamID
    Dim nXtRecID As Variant
    nXtRecID = objFilePlanComponent.getFilePlanComponentField(nNewRecordID, "XtRecID", False)
    UpdateProfileXmlWithXternalRecordID strResultXml, CStr(nXtRecID), CStr(nHostID)
    DeclareAsRecord = nNewRecordID
End Function
